#include <vector>
#include <array>

#include "sql.hpp"
#include "values/Similarity.hpp"
#include "canvas/Canvas.hpp"

enum DrawingStage
{
  setup,
  drawTree,
  drawBig,
  calSim,
  done,
};

constexpr int numberOfFunc = 2;

class Vapp
{
public:
  void init();
  void update();
  void draw();
  void deinit();

private:
  bool showSelection;
  bool showStats;
  sqlite3 *db;
  sqlite3_stmt *get_gen_num;
  std::vector<int64_t> ids;
  int64_t gens = -1;
  bool update_gen = false;
  bool enableAll = true;

  int32_t selected_id_index = -1;
  int32_t selected_gen = -1;
  DnaManagerData manager;
  DrawingStage stageOfDrawing = DrawingStage::done;

  Canvas canvas;
  RenderTexture2D treeTexture;
  int32_t drawTreeIndex = -1;

  RenderTexture2D bigTexture;
  int drawX = 0;
  int drawY = 0;
  void setUpManager();
 
  std::array<float, numberOfFunc> simil;
  std::vector<std::array<float, numberOfFunc>> similTable;

  void setUpTable();
};